<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Hide Price Hyva Compatibility
 */

namespace Amasty\HidePriceHyva\Block\Popup;

use Amasty\HidePrice\Model\ConfigProvider;
use Amasty\HidePrice\Model\Source\ReplaceButton;
use Magento\Framework\View\Element\Template;

class AddToCart extends Template
{
    /**
     * @var ConfigProvider
     */
    private ConfigProvider $configProvider;

    public function __construct(
        Template\Context $context,
        ConfigProvider $configProvider,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->configProvider = $configProvider;
    }

    protected function _beforeToHtml(): AddToCart
    {
        switch ($this->configProvider->getReplaceButtonType()) {
            case ReplaceButton::HIDE_PRICE_POPUP:
                $this->setTemplate('Amasty_HidePriceHyva::product/popup.phtml');
                break;
            case ReplaceButton::CUSTOM_FORM:
                $this->setTemplate('Amasty_HidePriceHyva::product/customform-popup.phtml');
                break;
        }

        return parent::_beforeToHtml();
    }
}
