<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Hide Price Hyva Compatibility
 */

namespace Amasty\HidePriceHyva\Block\Product;

use Amasty\HidePrice\Helper\Data;
use Amasty\HidePrice\Model\ConfigProvider;
use Magento\Framework\View\Element\Template;

class ButtonAligner extends Template
{
    /**
     * @var Data
     */
    private Data $helper;

    /**
     * @var ConfigProvider
     */
    private ConfigProvider $configProvider;

    public function __construct(
        Template\Context $context,
        Data $helper,
        ConfigProvider $configProvider,
        array $data = []
    ) {
        $this->helper = $helper;
        $this->configProvider = $configProvider;
        parent::__construct($context, $data);
    }

    protected function _toHtml(): string
    {
        if (!$this->shouldAddAlignment()) {
            return '';
        }

        return parent::_toHtml();
    }

    private function shouldAddAlignment(): bool
    {
        $product = $this->getParentBlock()->getProduct();

        return $product
            && $this->configProvider->getHideAddToCartValue() === 1
            && $this->helper->isApplied($product);
    }
}
