<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Hide Price Hyva Compatibility
 */

namespace Amasty\HidePriceHyva\Model\BlockRender;

use Amasty\HidePriceHyva\Api\BlockRenderInterface;
use Magento\Catalog\Api\Data\ProductInterface;

abstract class AbstractBlockRender implements BlockRenderInterface
{
    /**
     * @var string
     */
    protected string $html;

    /**
     * @var ProductInterface
     */
    protected ProductInterface $product;

    abstract public function isApplicable(string $blockName): bool;

    public function setHtml(string $html): void
    {
        $this->html = $html;
    }

    public function setProduct(ProductInterface $product): void
    {
        $this->product = $product;
    }
}
