<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Hide Price Hyva Compatibility
 */

namespace Amasty\HidePriceHyva\Model\BlockRender\ProductPage;

use Amasty\HidePrice\Model\ConfigProvider;
use Amasty\HidePriceHyva\Model\BlockRender\AbstractBlockRender;

class BundlePrice extends AbstractBlockRender
{
    /**
     * @var ConfigProvider
     */
    private ConfigProvider $configProvider;

    public function __construct(
        ConfigProvider $configProvider
    ) {
        $this->configProvider = $configProvider;
    }

    public function isApplicable(string $blockName): bool
    {
        return $blockName === 'product.info.bundle.price' && $this->configProvider->isHidePrice();
    }

    public function render(): string
    {
        return '';
    }
}
