<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Hide Price Hyva Compatibility
 */

namespace Amasty\HidePriceHyva\Model\BlockRender\ProductPage;

use Amasty\HidePrice\Model\ConfigProvider;
use Amasty\HidePrice\Helper\Data;
use Amasty\HidePriceHyva\Model\BlockRender\AbstractBlockRender;

class Price extends AbstractBlockRender
{
    /**
     * @var ConfigProvider
     */
    private ConfigProvider $configProvider;

    /**
     * @var Data
     */
    private Data $helper;

    public function __construct(
        ConfigProvider $configProvider,
        Data $helper
    ) {
        $this->configProvider = $configProvider;
        $this->helper = $helper;
    }

    public function isApplicable(string $blockName): bool
    {
        return $blockName === 'product.info.price' && $this->configProvider->isHidePrice();
    }

    public function render(): string
    {
        return $this->helper->getNewPriceHtmlBox($this->product);
    }
}
