<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Hide Price Hyva Compatibility
 */

namespace Amasty\HidePriceHyva\Model;

use Amasty\HidePriceHyva\Api\BlockRenderInterface;

class BlockRenderPool
{
    /**
     * @var BlockRenderInterface[]
     */
    private array $renderPool;

    /**
     * @param BlockRenderInterface[] $renderPool
     */
    public function __construct(
        array $renderPool
    ) {
        $this->renderPool = $renderPool;
    }

    public function render($product, $html, $blockName): string
    {
        foreach ($this->renderPool as $renderer) {
            if ($renderer->isApplicable($blockName)) {
                $renderer->setProduct($product);
                $renderer->setHtml($html);

                return $renderer->render();
            }
        }

        return $html;
    }
}
