<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Hide Price Hyva Compatibility
 */

namespace Amasty\HidePriceHyva\Plugin\Catalog\Block\Product\AbstractProduct;

use Amasty\HidePrice\Helper\Data;
use Amasty\HidePrice\Model\DomWrapperFactory;
use Amasty\HidePrice\Plugin\Catalog\Block\Product\ProductList\AbstractList;
use Hyva\Theme\Service\CurrentTheme;
use Magento\Catalog\Block\Product\AbstractProduct;
use Magento\Framework\Registry;
use Psr\Log\LoggerInterface;

class HideAddToCart extends AbstractList
{
    /**
     * @var CurrentTheme
     */
    private CurrentTheme $currentTheme;

    public function __construct(
        Data $helper,
        Registry $coreRegistry,
        DomWrapperFactory $domWrapperFactory,
        LoggerInterface $logger,
        CurrentTheme $currentTheme
    ) {
        parent::__construct($helper, $coreRegistry, $domWrapperFactory, $logger);
        $this->currentTheme = $currentTheme;
    }

    public function afterToHtml(AbstractProduct $subject, string $html): string
    {
        if (!$this->currentTheme->isHyva() || $subject->getNameInLayout() !== 'product_list_item') {
            return $html;
        }

        return $this->replaceButtonFromHtml($html);
    }

    /**
     * @param array $productData
     * @return string
     */
    protected function generateSelector($productData): string
    {
        return 'form[action*="product/' . $productData['id'] . '"] button.btn.btn-primary';
    }
}
