<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Hide Price Hyva Compatibility
 */

namespace Amasty\HidePriceHyva\Plugin\HidePrice\Plugin\Framework\Pricing\Render;

use Hyva\Theme\Service\CurrentTheme;
use Magento\Framework\Pricing\SaleableInterface;
use Amasty\HidePrice\Plugin\Framework\Pricing\Render;

class DisableGenerateJs
{
    /**
     * @var CurrentTheme
     */
    private CurrentTheme $currentTheme;

    public function __construct(
        CurrentTheme $currentTheme
    ) {
        $this->currentTheme = $currentTheme;
    }

    /**
     * @param Render $subject
     * @param SaleableInterface $saleableItem
     * @param string $priceCode
     * @param array $arguments
     * @return null
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function beforeRenderPrice(
        Render $subject,
        SaleableInterface $saleableItem,
        string $priceCode,
        array $arguments = []
    ) {
        if ($this->currentTheme->isHyva()) {
            $saleableItem->setHidePriceObserved(true);
        }

        return null;
    }
}
