<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Hide Price Hyva Compatibility
 */

namespace Amasty\HidePriceHyva\Plugin\Hyva\Theme\ViewModel\ProductCompare;

use Amasty\HidePrice\Model\ConfigProvider;
use Hyva\Theme\ViewModel\ProductCompare;

class HideCompare
{
    /**
     * @var ConfigProvider
     */
    private ConfigProvider $configProvider;

    public function __construct(
        ConfigProvider $configProvider
    ) {
        $this->configProvider = $configProvider;
    }

    /**
     * @param ProductCompare $subject
     * @param bool $result
     * @return bool
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function afterShowInProductList(ProductCompare $subject, bool $result): bool
    {
        return $result && !$this->shouldHideCompare();
    }

    /**
     * @param ProductCompare $subject
     * @param bool $result
     * @return bool
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function afterShowOnProductPage(ProductCompare $subject, bool $result): bool
    {
        return $result && !$this->shouldHideCompare();
    }

    private function shouldHideCompare(): bool
    {
        return $this->configProvider->isEnabled() && $this->configProvider->isHideCompare();
    }
}
