<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Hide Price Hyva Compatibility
 */

namespace Amasty\HidePriceHyva\Plugin\Hyva\Theme\ViewModel\Wishlist;

use Amasty\HidePrice\Model\ConfigProvider;
use Hyva\Theme\ViewModel\Wishlist;

class HideWishlist
{
    /**
     * @var ConfigProvider
     */
    private ConfigProvider $configProvider;

    public function __construct(
        ConfigProvider $configProvider
    ) {
        $this->configProvider = $configProvider;
    }

    /**
     * @param Wishlist $subject
     * @param bool $result
     * @return bool
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function afterIsEnabled(Wishlist $subject, bool $result): bool
    {
        return $result && !$this->shouldHideWishlist();
    }

    private function shouldHideWishlist(): bool
    {
        return $this->configProvider->isEnabled() && $this->configProvider->isHideWishlist();
    }
}
